// kth_bst.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <vector>
#include <iostream>

typedef struct node{

	int data;
	node * left;
	node * right;

	node(int v) : data(v), left(NULL), right(NULL) { }; 
};

void inorder(node * current, int k, std::vector<int> & v)
{
	if ((current == NULL) || v.size() == k)
		return;

	inorder(current->left, k, v);
	v.push_back(current->data);
	inorder(current->right, k, v);
}


void kthSmallestBST(node * current, int k)
{
	if (k < 1) return;
	std::vector<int> v;

	inorder(current, k, v);
    if (v.size() >= k)
	{
		for (unsigned int i=0; i < k; i++)
			std::cout << v[i] << " ";
	}
}

int _tmain(int argc, _TCHAR* argv[])
{
	int N;
	node * root = new node(10);               //          10
	root->left = new node(5);                 //      5       12
	root->right = new node(12);
	root->left->left = new node(1);         //     1   6
	root->left->right = new node(6);
	
	kthSmallestBST(root, 3);

	std::cin >> N;	
	return 0;
}

